local _M = class("LayerBase", CCLayerColor)
local _priority = -1100

local function AddPriorityLv()
    _priority = _priority - 100
end

local function SubPriorityLv()
    _priority = _priority + 100
end

function _M:ctor( args )
    self:enableNodeEvents()
    self:setColor(ccc3(0,0,0))
    self:setOpacity(125)
    if self.onCreate then self:onCreate(args) end
end

function _M:getTouchPriority()
    return _priority
end

function _M:onEnter_()
    AddPriorityLv()
    CCNode.onEnter_(self)
end

function _M:onExit_()
    SubPriorityLv()
    CCNode.onExit_(self)
end

function _M:enterAction( target, oPos, tPos )
    local winSz = CCDirector:sharedDirector():getWinSize()
    oPos = oPos or ccp(winSz.width/2, -winSz.height/2)
    tPos = tPos or ccp(winSz.width/2, winSz.height/2)

    target:move(oPos)
    target:runAction(CCEaseBackOut:create(CCMoveTo:create(0.4, tPos)))
end

function _M:exitAction( target, tPos )
    local winSz = CCDirector:sharedDirector():getWinSize()
    tPos = tPos or ccp(winSz.width/2, -winSz.height/2)

    local array = CCArray:create()
    array:addObject(CCMoveTo:create(0.3, tPos))
    array:addObject(CCCallFunc:create(handler(self, self.removeSelf)))
    target:runAction(CCSequence:create(array))
end

return _M