local Widget = Widget

local _setPosition = Widget.setPosition
local _setSize = Widget.setSize

function Widget:setPosition( x, y )
    if y then
        _setPosition(self, ccp(x, y))
    else
        if type(x) == "table" then
            _setPosition(self, ccp(x.x, x.y))
        else
            _setPosition(self, x)
        end
    end
    return self
end

function Widget:setSize( w, h )
    if h then
        _setSize(self, CCSizeMake(w, h))
    else
        if type(w) == "table" then
            _setSize(self, CCSizeMake(w.width, w.height))
        else
            _setSize(self, w)
        end
    end
    return self
end

function Widget:onTouch(callback)
    self:addTouchEventListener(function(sender, state)
        local event = {x = 0, y = 0}
        if state == 0 then
            event.name = "began"
        elseif state == 1 then
            event.name = "moved"
        elseif state == 2 then
            event.name = "ended"
        else
            event.name = "cancelled"
        end
        event.target = sender
        callback(event)
    end)
    return self
end

function Widget:setCascadeColorEnabled( ... )
    -- body
end

function Widget:setCascadeOpacityEnabled( ... )
    -- body
end

function Widget:setLayoutComponentEnabled( ... )
    -- body
end